namespace eval NvCBCA {

    proc MatchOnI {i jVal tol} {
        global Clust NvCBCA
        set nClust $Clust(nClust)
        set matches ""
        if {$jVal == "All"} {
            set jFirst 0
            set jLast [expr $nClust-1]
        } else {
            set jFirst $jVal
            set jLast $jVal
        }
        for {set j $jFirst} {$j<= $jLast} {incr j} {
            update
            if {$i==$j} { continue }
            set results [eval $NvCBCA(matchScript) $i $j $tol [eval NvCBCAGetPkLists]]
            foreach result $results {
                set score [lindex $result 0]
                set nmatch [lindex $result 1]
                set apeaks [lindex $result 2]
                set bpeaks [lindex $result 3]
                set restype [lindex $result 4]
                if {$nmatch > 0} {
                    lappend matches [list $j $score 0 $nmatch $apeaks $bpeaks $restype]
                }
            }
        }
        puts -nonewline " [llength $matches]"
        return [lsort -index 1 -real -decreasing $matches]
    }

    proc FilterPeaks {} {
        global Clust NvCBCA
        nv_peak template $NvCBCA(filter,list) $NvCBCA(HNdim) $NvCBCA(filter,tolHN) $NvCBCA(Ndim) $NvCBCA(filter,tolN)
        foreach peaklist $NvCBCA(filterLists) {
            set npeaks 0
            set sweep_ppm [expr [lindex [eval nv_peak sw $peaklist] 2] / \
            [lindex [eval nv_peak sf $peaklist] 2]]
	   
            foreachpeak ipeak $peaklist {
                set hn [nv_peak elem $NvCBCA(HNdim).P $peaklist.$ipeak]
                set n [nv_peak elem $NvCBCA(Ndim).P $peaklist.$ipeak]
                set peaks [nv_peak find $NvCBCA(filter,list) $hn $n]
	#	puts "$hn $n"
               # lappend peaks [nv_peak find $NvCBCA(filter,list) $hn [expr $n+$sweep_ppm]] ;# allow for folding
               # lappend peaks [nv_peak find $NvCBCA(filter,list) $hn [expr $n-$sweep_ppm]]
		#puts $peaks
                if {[llength $peaks] == 0} {

                    puts "$peaklist.$ipeak marked for deletion"
                    nv_peak elem stat $peaklist.$ipeak -1
                    incr npeaks
                }
            }
            puts " -> Marked $npeaks peaks from list $peaklist"
        }
    }
}
